<?PHP
/**
 * Ajax request to provide an autocomplete-box json-array
 *
 *
 * Copyright © 2015 kaempf-nk.de
 * Licensed under the MIT license
 * http://www.kaempf-nk.de/webseitengestaltung/js/license.txt
 *
 * History: 2015-11-22 - first release
 */
 
/*
 * 	create database structure in mySQL
 * 
CREATE TABLE address (
	adrid INT NOT NULL AUTO_INCREMENT , 
	company VARCHAR(50) NULL , 
	surname VARCHAR(50) NULL , 
	givenname VARCHAR(50) NULL , 
	street VARCHAR(100) NULL , 
	country VARCHAR(5) NULL , 
	zipcode VARCHAR(10) NULL ,
	location VARCHAR(50) NULL , 
	adrindex VARCHAR(330) NULL , 
	PRIMARY KEY (adrid)
);

															// trigger to maintain the field "adrindex"
															// adrindex will be used to search - it's easier to search in this common field as to search in all fields separately

create trigger insert_address
before insert on address
for each row
set new.adrindex= concat(new.company, ' ', new.surname, ' ', new.givenname, ' ', new.street, ' ', new.country, ' ', new.zipcode, ' ', new.location);

create trigger update_address
before update on address
for each row
set new.adrindex= concat(new.company, ' ', new.surname, ' ', new.givenname, ' ', new.street, ' ', new.country, ' ', new.zipcode, ' ', new.location);

															// add some text records

INSERT INTO `address` (`company`, `surname`, `givenname`, `street`, `country`, `zipcode`, `location`) VALUES ('Freedom Ltd.', 'Chen', 'Quang', 'Anfield Road 1', 'GB', '12345', 'Town');
INSERT INTO `address` (`company`, `surname`, `givenname`, `street`, `country`, `zipcode`, `location`) VALUES ('HomeLand', 'Doe', 'John', 'Cityhall 4', 'GB', '23456', 'Village');
INSERT INTO `address` (`company`, `surname`, `givenname`, `street`, `country`, `zipcode`, `location`) VALUES ('My Company', 'Smith', 'Andrew', 'Harbour 2', 'GB', '34567', 'Oxygen town');
INSERT INTO `address` (`company`, `surname`, `givenname`, `street`, `country`, `zipcode`, `location`) VALUES ('Brotlos AG', 'Müller', 'Peter', 'Hinterm Berg 3', 'D', '12345', 'Kleinkleckersdorf');
INSERT INTO `address` (`company`, `surname`, `givenname`, `street`, `country`, `zipcode`, `location`) VALUES ('Wichtig GmbH', 'Wichtig', 'Willi', 'Boulevard 7', 'D', '23456', 'Großmannsdorf');
INSERT INTO `address` (`company`, `surname`, `givenname`, `street`, `country`, `zipcode`, `location`) VALUES ('Helfer AG', 'Schmidt', 'Otto', 'Rosenweg 55', 'D', '34567', 'Schluchtelhausen');
INSERT INTO `address` (`company`, `surname`, `givenname`, `street`, `country`, `zipcode`, `location`) VALUES ('Home AG', 'Schulze', 'Karl', 'Baumallee 55', 'D', '45678', 'Baumstadt');

*/
header('Content-Type: text/javascript');
															// connect to database (please set your own values)
	$db = @new mysqli( 'servername', 'user', 'password', 'database', port);
	if (mysqli_connect_errno()) {
		printf("Connect failed: %s\n", mysqli_connect_error());
		exit();
	}
	$db->set_charset("utf8");								// set character set to UTF-8 to due e.g. German special characters
	
	
	$sInput = $_GET['term'];								// input term
	$sCallback = $_GET['callback'];							// jsonp callback parameter

															// each input value separated by blank will be used as a separate search phrase
	$aInput = explode(' ', $sInput);
	$n = count($aInput);
	
	$sBindType = '';										// assemble the sql statement with parameters (faster and more secure as a simple concatinated statemant)
	for($i = 0; $i < $n; $i++) {
		$sBindType .= 's';
	}
	
	$aBindPara = array();
	$aBindPara[] = & $sBindType;
	
	for($i = 0; $i < $n; $i++) {
		$aInput[$i] = '%'.$aInput[$i].'%';
		$aBindPara[] = & $aInput[$i];
	}
	
	$sql = 'SELECT company, surname, givenname, street, country, zipcode, location FROM address WHERE';
	for($i = 0; $i < $n; $i++) {
		if ($i > 0 ) $sql .= ' and ';
		$sql .= ' adrindex like ?';
	}
						 		
	$stmt = $db->prepare($sql);								// prepare statement
	call_user_func_array(array($stmt, 'bind_param'), $aBindPara);

	$stmt->execute();										// execute the statement
	$aResult = array();
	if (method_exists($stmt,'get_result')) {				// get_result exists, if you use the native driver
		$result = $stmt->get_result();
		while($row=mysqli_fetch_assoc($result)){			// fetch the results
			$aResult[]=$row;
		}
	} else {												// fallback, if the native driver doesn't exists
		$stmt->store_result();
		for ( $i = 0; $i < $stmt->num_rows; $i++ ) {
			$meta = $stmt->result_metadata();
			$aParams = array();
			while ( $field = $meta->fetch_field() ) {
				$aParams[] = &$aResult[$i][$field->name];
			}
			call_user_func_array( array( $stmt, 'bind_result' ), $aParams );
			$stmt->fetch();
		}
	}
	
	if (sizeof($aResult)) {									// convert result to json and get back as jsonp-callback
		echo $sCallback.'('.json_encode($aResult).')';
	} else {
		echo $sCallback.'([])';
	}

	mysqli_stmt_close($stmt);								// close the resources
	mysqli_close($db);

?>